export default function ({ sendRequest, setData, platform, router }) {
  return class HomeCategoryEntry {
    constructor({ props, report, pageInfo }) {
      this.props = props;
      this.list = props.list;
    }

    onLoad() {
      setData({
        itemList: this.list.map((item, index) => ({ ...item, index })),
      });
    }

    getAgoraItemReport() {
      const result = {};
      const index = (this.url && this.url.indexOf('?')) || -1;

      if (index !== -1) {
        const str = this.url.substr(index + 1);
        const strs = str.split('&');

        for (let i = 0; i < strs.length; i++) {
          const [key, value] = strs[i].split('=');
          result[key] = decodeURI(value);
        }
      }

      const title = (this.data.itemList && this.data.itemList[this.index] && this.data.itemList[this.index].title) || '';

      return {
        itemId: result.PageID,
        itemName: encodeURIComponent(title),
        itemPosition: this.index,
      };
    }
  };
};
