export default function ({ sendRequest, setData, platform }) {
  return class HomeCategoryEntry {
    constructor({ props }) {
      this.item = props.item || '';
    }

    itemReportData() {
      const { item = {} } = this;
      const result = {};
      const position = (item.url && item.url.indexOf('?')) || -1;
      if (position !== -1) {
        const str = item.url.substr(position + 1);
        const strs = str.split('&');
        for (let i = 0; i < strs.length; i++) {
          const [key, value] = strs[i].split('=');
          result[key] = decodeURI(value);
        }
      }
      return {
        itemId: result.PageID || '',
        itemName: encodeURIComponent(this.item && this.item.title),
        itemPosition: (this.item && this.item.index) || '',
      };
    }
  };
};
